# SPDX-License-Identifier: (GPL-2.0-only OR BSD-2-Clause)
%YAML 1.2
---
$id: http://devicetree.org/schemas/net/wireless/qca,ath9k.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Qualcomm Atheros ath9k wireless devices Generic Binding

maintainers:
  - Kalle Valo <kvalo@codeaurora.org>

description: |
  This node provides properties for configuring the ath9k wireless device.
  The node is expected to be specified as a child node of the PCI controller
  to which the wireless chip is connected.

allOf:
  - $ref: ieee80211.yaml#

properties:
  compatible:
    enum:
      - pci168c,0023  # AR5416
      - pci168c,0024  # AR5418
      - pci168c,0027  # AR9160
      - pci168c,0029  # AR9220 and AR9223
      - pci168c,002a  # AR9280 and AR9283
      - pci168c,002b  # AR9285
      - pci168c,002c  # AR2427 - 802.11n bonded out
      - pci168c,002d  # AR9227
      - pci168c,002e  # AR9287
      - pci168c,0030  # AR9380, AR9381 and AR9382
      - pci168c,0032  # AR9485
      - pci168c,0033  # AR9580 and AR9590
      - pci168c,0034  # AR9462
      - pci168c,0036  # AR9565
      - pci168c,0037  # AR1111 and AR9485

  reg:
    maxItems: 1

  interrupts:
    maxItems: 1

  ieee80211-freq-limit: true

  qca,no-eeprom:
    $ref: /schemas/types.yaml#/definitions/flag
    description:
      Indicates that there is no physical EEPROM connected

  nvmem-cells:
    items:
      - description: Reference to an nvmem node for the MAC address
      - description: Reference to an nvmem node for calibration data

  nvmem-cell-names:
    items:
      - const: mac-address
      - const: calibration

required:
  - compatible
  - reg

additionalProperties: false

examples:
  - |
    pcie0 {
      #address-cells = <3>;
      #size-cells = <2>;
      wifi@0,0 {
        compatible = "pci168c,002d";
        reg = <0 0 0 0 0>;
        interrupts = <3>;
        qca,no-eeprom;
      };
    };
  - |
    pci0 {
      #address-cells = <3>;
      #size-cells = <2>;
      wifi@0,11 {
        compatible = "pci168c,0029";
        reg = <0x8800 0 0 0 0>;
        nvmem-cells = <&macaddr_art_c>, <&cal_art_1000>;
        nvmem-cell-names = "mac-address", "calibration";
      };
    };
